#!/bin/bash
# Thomas Reerink
#
# This script adds some non-cmor variables (which thus do not exit in the CMIP6 data request) to the end of the cmor table in question.
#
# This scripts requires no arguments.
#
# Run example:
#  ./add-non-cmor-variables.sh
#

if [ "$#" -eq 0 ]; then

 add_lpjg_variables=True            
 

 if [ add_lpjg_variables ]; then
  # cLan1

  head --lines=-3 ../resources/tables/CMIP6_Emon.json                                                                                                      >  extended-CMIP6_Emon.json

  echo '        },                                                                                                                     ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '        "cLand1": {                                                                                                            ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "frequency": "mon",                                                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "modeling_realm": "land",                                                                                          ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "standard_name": "mass_content_of_carbon_in_vegetation_and_litter_and_soil_and_forestry_and_agricultural_products",' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "units": "kg m-2",                                                                                                 ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "cell_methods": "area: mean where land time: mean",                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "cell_measures": "area: areacella",                                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "long_name": "Total Carbon in All Terrestrial Carbon Pools",                                                       ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "comment": "Report missing data over ocean grid cells. For fractional land report value averaged over the land fraction.",  ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json 
  echo '            "dimensions": "longitude latitude time",                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "out_name": "cLand1",                                                                                              ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "type": "real",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "positive": "",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "valid_min": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "valid_max": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "ok_min_mean_abs": "",                                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json
  echo '            "ok_max_mean_abs": ""                                                                                              ' | sed 's/\s*$//g' >> extended-CMIP6_Emon.json

  echo '        }'                                                                                                                                         >> extended-CMIP6_Emon.json
  echo '    }'                                                                                                                                             >> extended-CMIP6_Emon.json
  echo '}'                                                                                                                                                 >> extended-CMIP6_Emon.json

  mv -f extended-CMIP6_Emon.json ../resources/tables/CMIP6_Emon.json

  head --lines=-3 ../resources/tables/CMIP6_Lmon.json                                                                                                      >  extended-CMIP6_Lmon.json

  echo '        },                                                                                                                     ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '        "fco2nat": {                                                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "frequency": "mon",                                                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "modeling_realm": "atmos",                                                                                         ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "standard_name": "surface_upward_mass_flux_of_carbon_dioxide_expressed_as_carbon_due_to_emission_from_natural_sources",' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "units": "kg m-2 s-1",                                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "cell_methods": "area:time: mean",                                                                                 ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "cell_measures": "area: areacella",                                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "long_name": "Surface Carbon Mass Flux into the Atmosphere Due to Natural Sources [kgC m-2 s-1]",                  ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "comment": "This is what the atmosphere sees (on its own grid).  This field should be equivalent to the combined natural fluxes of carbon  that account for natural exchanges between the atmosphere and land (nep) or ocean (fgco2) reservoirs.",                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json 
  echo '            "dimensions": "longitude latitude time",                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "out_name": "fco2nat",                                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "type": "real",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "positive": "",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "valid_min": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "valid_max": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "ok_min_mean_abs": "",                                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json
  echo '            "ok_max_mean_abs": ""                                                                                              ' | sed 's/\s*$//g' >> extended-CMIP6_Lmon.json

  echo '        }'                                                                                                                                         >> extended-CMIP6_Lmon.json
  echo '    }'                                                                                                                                             >> extended-CMIP6_Lmon.json
  echo '}'                                                                                                                                                 >> extended-CMIP6_Lmon.json

  mv -f extended-CMIP6_Lmon.json ../resources/tables/CMIP6_Lmon.json

  head --lines=-3 ../resources/tables/CMIP6_Eyr.json                                                                                                       >  extended-CMIP6_Eyr.json

  echo '        },                                                                                                                     ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '        "cLandYr": {                                                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "frequency": "yr",                                                                                                 ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "modeling_realm": "land",                                                                                          ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "standard_name": "mass_content_of_carbon_in_vegetation_and_litter_and_soil_and_forestry_and_agricultural_products",' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "units": "kg m-2",                                                                                                 ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "cell_methods": "area: mean where land time: mean",                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "cell_measures": "area: areacella",                                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "long_name": "Total Carbon in All Terrestrial Carbon Pools",                                                       ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "comment": "Report missing data over ocean grid cells. For fractional land report value averaged over the land fraction.",  ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json 
  echo '            "dimensions": "longitude latitude time",                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "out_name": "cLandYr",                                                                                               ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "type": "real",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "positive": "",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "valid_min": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "valid_max": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "ok_min_mean_abs": "",                                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "ok_max_mean_abs": ""                                                                                              ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '        },                                                                                                                     ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json


  echo '        "cFluxYr": {                                                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "frequency": "yr",                                                                                                 ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "modeling_realm": "land",                                                                                          ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "standard_name": "cFluxYr",                                                                                        ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "units": "kg m-2 yr-1",                                                                                            ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "cell_methods": "area: mean where land time: mean",                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "cell_measures": "area: areacella",                                                                                ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "long_name": "cFluxYr",                                                                                            ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "comment": "cFluxYr",                                                                                              ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json 
  echo '            "dimensions": "longitude latitude time",                                                                           ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "out_name": "cFluxYr",                                                                                               ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "type": "real",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "positive": "",                                                                                                    ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "valid_min": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "valid_max": "",                                                                                                   ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "ok_min_mean_abs": "",                                                                                             ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json
  echo '            "ok_max_mean_abs": ""                                                                                              ' | sed 's/\s*$//g' >> extended-CMIP6_Eyr.json

  echo '        }'                                                                                                                                         >> extended-CMIP6_Eyr.json
  echo '    }'                                                                                                                                             >> extended-CMIP6_Eyr.json
  echo '}'                                                                                                                                                 >> extended-CMIP6_Eyr.json

  mv -f extended-CMIP6_Eyr.json ../resources/tables/CMIP6_Eyr.json

 else
    echo '  '
    echo '  Noting done, no set of variables has been selected to add to the tables.'
    echo '  '
 fi

else
    echo '  '
    echo '  This scripts requires no argument:'
    echo '  ' $0
    echo '  '
fi
