#!/usr/bin/env bash
#shellcheck disable=SC2155

#####################################################################################################################
# Functions for handling filesystem operations for data transfer machines part of marenostrum5 platform
# Author: J.R.Berlin
#####################################################################################################################

. "${PROJDIR}/platforms/marenostrum5/utils.sh"

#####################################################################################################################
# any override from the common libraries defined in filesystem.sh or new function goes below here
#####################################################################################################################

#####################################################################################################################
# Globals:
#   GROUP, USER, EXPID, START_date, MEMBER, GROUP, PATH
# Arguments:
#   None
# Returns:
#   None
# Purpose: set the global variables refering to common paths to be used by the jobs running in the
#         underlying architecture ( initial conditions, grib modules, intermediate storage,etc )
#####################################################################################################################
function setup_paths() {
  setup_common_paths
}

#####################################################################################################################
# Globals:
#   None
# Arguments:
#   None
# Returns:
#   None
# Purpose: auxiliary function to common environment vars that will be used when the job
#          executes in the transfer node
#####################################################################################################################
function setup_environment_vars() {
  setup_common_environment_vars
  #Machine for the ece3postproc
  export ECE3_POSTPROC_MACHINE=mn5
  export SCRATCH=/gpfs/scratch/${GROUP}/${USER}
}
